var SimpleMail, storage;
var folders = window.arguments[0].inn.folders;
var folderTree = window.arguments[0].inn.folderTree;
var folder = window.arguments[0].inn.folder;

function initialize() {
  SimpleMail = SimpleMailUtils.getBrowserWindow().SimpleMail;
  storage = SimpleMail.storage;
  populateAccountId();
  today = new Date();
  SimpleMailPrefs.setString('dateValue', today);
  SimpleMailDom.get("choice").selectedIndex=0;
  SimpleMailDom.get("choice2").disabled = true;
  SimpleMailDom.get("accountId").selectedIndex=0;  
  SimpleMailDom.get("accountId").disabled = true;
  SimpleMailDom.get("exportType").disabled = true;
  SimpleMailDom.get("deletemessages").disabled = true;
  SimpleMailDom.get("choosedateExp").disabled = true;   
}
   
function choice(selectedIndex) {
  if (SimpleMailDom.get("choice").selectedIndex == 0) {
    SimpleMailDom.get("importType").disabled = false;  
    SimpleMailDom.get("choice2").disabled = true;
    SimpleMailDom.get("accountId").disabled = true;
    SimpleMailDom.get("exportType").disabled = true;
    SimpleMailDom.get("deletemessages").disabled = true;
    SimpleMailDom.get("choosedateExp").disabled = true;    
  }
  else {
    SimpleMailDom.get("importType").disabled = true;  
    SimpleMailDom.get("choice2").disabled = false;
    SimpleMailDom.get("accountId").disabled = false;
    SimpleMailDom.get("exportType").disabled = false;
    SimpleMailDom.get("deletemessages").disabled = false;
    SimpleMailDom.get("choosedateExp").disabled = false;    
  }
} 

function choice2(selectedIndex) {
  if (SimpleMailDom.get("choice2").selectedIndex == 0) {
    SimpleMailDom.get("accountId").disabled = false;
  }  
  else if (SimpleMailDom.get("choice2").selectedIndex == 1) {
    SimpleMailDom.get("accountId").disabled = true;
  }
} 

function importType(selectedIndex) {
} 

function exportType(selectedIndex) {
} 
  
function browseDataDirectory() {
  var file = SimpleMailFile.chooseFile("folder");
  if (file) {
    SimpleMailDom.get("dataDirectory").value = file.path;
    SimpleMailPrefs.setString("dataDirectory", file.path);
  }
}

function populateAccountId() {
  var accounts = storage.getAccounts();
  var popup = SimpleMailDom.get("accountId").menupopup;

  for(var i = 0; i < accounts.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", accounts[i]);
    menuitem.setAttribute("value", accounts[i].id);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}

function updateWindow() {
  if ((SimpleMailDom.get("exportType").selectedIndex == 2)) {
    var archiveType = SimpleMailDom.get("exportType").selectedIndex;
    window.arguments[0].out = {exportType:exportType};
    close();
  }
  else {
    close();
  }
}

function next() {
  var deck = SimpleMailDom.get("stateDeck");
  var index = deck.getAttribute("selectedIndex");
  switch (index) {
  case "0":
  deck.setAttribute("selectedIndex", "1");
  case "1":
  okDialog();
  break;
  case "2":
  updateWindow();
  break;  
  }
}    

function okDialog() {
//Import
  if (SimpleMailDom.get("choice").selectedIndex == 0) {
    if ((SimpleMailDom.get("importType").selectedIndex == 0)) {
      if (importPST() == true) {
        ShowResults(true);
        return(true);
      }
      else {
        setProgress(5);
        return(false);
      }
    ShowResults(false);
    }

    else if ((SimpleMailDom.get("importType").selectedIndex == 1)) {
      if (importBird() == true) {
        ShowResults(true);
        return(true);
      }
      else {
        setProgress(5);
        return(false);
      }
    ShowResults(false);
    }

  ShowResults(false);
  }
//Export   
  else if (SimpleMailDom.get("choice").selectedIndex == 1) {
    if (SimpleMailDom.get("exportType").selectedIndex == 0) {
      if (exportPST() == true) {
        ShowResults(true);
        return(true);
      }
      else {
        setProgress(5);
        return(false);
      }
    ShowResults(false);
    }
    else if (SimpleMailDom.get("exportType").selectedIndex == 1) {
      if (exportBird() == true) {
        ShowResults(true);
        return(true);
      }
      else {
        setProgress(5);
        return(false);
      }
  ShowResults(false);
  }        

  ShowResults(false);
  }  
}
 
function setProgress (pct) {
  if (pct <= 100) {
    var progressMeter = SimpleMailDom.get("progressMeter");
    progressMeter.value =  pct;
   }
  return; 
}
   
function attachStrings(aNode, aString) {
  var attachNode = SimpleMailDom.get(aNode);
  var strings = aString.split("\n");
  
  for (var i = 0; i < strings.length; i++) {
    if (strings[i]) {
      var currNode = document.createTextNode(strings[i]);
      attachNode.appendChild(currNode);
      var br = document.createElementNS("http://www.w3.org/1999/xhtml", 'br');
      attachNode.appendChild(br);
    }
  }
}

function ShowResults(good) {
  var result;

  if (SimpleMailDom.get("choice").selectedIndex == 0) {
    if (good) {
      result = SimpleMailBundle.getString("createdImport");
    }
    else { 
      result = SimpleMailBundle.getString("errorImport");
    }
  }
  else if (SimpleMailDom.get("choice").selectedIndex == 1) {
    if (good) {
      result = SimpleMailBundle.getString("createdExport");
    }
    else { 
      result = SimpleMailBundle.getString("errorExport");
    }  
  }

  attachStrings("results", result);
  var deck = SimpleMailDom.get("stateDeck");
  deck.setAttribute("selectedIndex", "2");
  var nextButton = SimpleMailDom.get("forward");
  nextButton.label = nextButton.getAttribute("finishedval");
  nextButton.removeAttribute("disabled");
  var cancelButton = SimpleMailDom.get("cancel");
  cancelButton.setAttribute("hidden", "true");
}

function getString(statement, id) {
  var text = "text: ";
  var value = statement.getString(id);
  return value && value.substr(0, text.length) == text ? value.substr(text.length) : value;
}
    
function importPST() {
alert("import PST");
  setProgress(90);
  return(true);
}

function importBird() {
  importFolder();
  setProgress(90);
  return(true);
}

function exportPST() {
alert("export PST");
  setProgress(90);
  return(true);
}
 
function exportBird() {
  var deck = SimpleMailDom.get("stateDeck");
  var dateValue = new Date(SimpleMailPrefs.getString('dateValue'));
  if (new Date(SimpleMailPrefs.getString('dateValue')) > today ){
    var confirmText = SimpleMailBundle.getString("exportAlert");
      if (!SimpleMailUtils.confirm(confirmText)) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
   }
   
//Get msgs for account   
  if (SimpleMailDom.get("choice2").selectedIndex == 0) {
    var selectedAccount = SimpleMailDom.get("accountId").selectedItem.value;
    var Accountlabel = SimpleMailDom.get("accountId").selectedItem.label;

    var msg = new Array();  
    var msg = SimpleMail.storage.getAccountMessages(selectedAccount);
    
    var messagesDate = new Array();
    for(var i = msg.length - 1; i >= 0; i--) {    
      if ((msg[i].date)< dateValue) {
        messagesDate.push(msg[i]);
      }
    }
  }
  else {
//Get msgs for selected folder
    var folder = window.arguments[0].inn.folder;
    //Get msgs in subfolders
    var msg = new Array();
    forEachFolder(folder, function(f) {
      msg = msg.concat(storage.getFolderMessages(f.id));
    });
    
    var messagesDate = new Array();
    for(var i = msg.length - 1; i >= 0; i--) {    
      if ((msg[i].date)< dateValue) {
        messagesDate.push(msg[i]);
      }
    }    
  }
  setProgress(10);
        
//Check if messages exists 
  if (msg.length < 1 || messagesDate.length < 1) {
    var confirmText = SimpleMailBundle.getString("nomailAlertExp");
    SimpleMailUtils.alert(confirmText);
    deck.setAttribute("selectedIndex", "0");
    return;    
  }
    
//Create file    
  if ((SimpleMailDom.get("exportType").selectedIndex == 0)) {
    alert("Create PST File");
    /*if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    } */    
  }
  else if ((SimpleMailDom.get("choice2").selectedIndex == 0) && (SimpleMailDom.get("exportType").selectedIndex == 1)) {
    var file = SimpleMailFile.chooseFile("save", [], Accountlabel+SimpleMailDate.toShortString(dateValue));
    if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    } 
  }
  else if ((SimpleMailDom.get("choice2").selectedIndex == 1) && (SimpleMailDom.get("exportType").selectedIndex == 1)) {
    var file = SimpleMailFile.chooseFile("save", [], folder.getName()+" - "+SimpleMailDate.toShortString(dateValue));
    if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    } 
  }
    
  var out = SimpleMailFile.createOutputStream(file);
  setProgress(20);
  
//Write file
  for(var i = msg.length - 1; i >= 0; i--) {
    if ((msg[i].date)< dateValue) {
      var source = SimpleMailFile.getAttachmentsDirectory(msg[i].attachmentsDir);
      source.append(SimpleMailFile.MESSAGE_SOURCE);
      out.write("From - " + new Date(msg[i].date) + "\r\n");
      out.write(SimpleMailFile.readFile(source) + "\r\n\r\n");
      setProgress(30);
    }   
  }
  out.close();
  setProgress(40);
          
//Delete messages
  if (SimpleMailDom.get('deletemessages').checked) {
    var msgs = new Array();
      for(var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date)< dateValue) {
          msgs.push(msg[i]);
        }
      setProgress(80);        
      }
    var confirmText = SimpleMailBundle.getString("deleteMessages");
    SimpleMail.askDeleteMail(msgs, confirmText, window);
    setProgress(80);
  }
  setProgress(90);
  return(true);
}